<?php
/*
Extension Name: User Messages
Extension Url: http://www.two-antennas.com/category/vanilla/
Description: Allows users to post messages to other users <a href="settings.php?PostBackAction=InstallUserMessages">Click to Install after enabling the extension</a> or go to settings.php?PostBackAction=InstallUserMessages
Version: 0.1.1
Author: Michael Schieben
Author Url: http://www.two-antennas.com/

- The Extension adds a new Table to the databse automatically

- Changelog
	0.1.1
	- Bugfix: Display of Messages
	- Bugfix: Typo when message sent
	- Bugfix On Installation: Column Visited added to SQL Statement
	- Bugfix: Undefined $AccountUser
	0.1
	- Initial Release

*/

/* =Dictonary
--------- --------- --------- --------- --------- --------- --------- */
$Context->Dictionary["UserMessagesTitle"] = "User Messages";

/*////////////////////////////////
//  @name:  		UserMessages
//  @description: 	Handels basic functionality for UserMessages
*/
	
class UserMessages {

/* =Editable Variables 
--------- --------- --------- --------- --------- --------- --------- */

	
	/*////////////////////////////////
	//  @name:  		TableName
	//  @description: 	TableName of the new Table, don't change once installed
	*/
	var $TableName = "Messages";

/* =Noneditable Variables 
--------- --------- --------- --------- --------- --------- --------- */

	var $Name = "UserMessages";

	var $PrefixedTableName = "";

/* =Constructor
--------- --------- --------- --------- --------- --------- --------- */

	/*////////////////////////////////
	//  @name:  		UserMessages
	//  @description:   Constructor
	//  @param: 		Object Context
	//  @return:		-
	*/
	function UserMessages(&$Context) {
		$this->Context = &$Context;

		$this->Context->DatabaseTables[$this->TableName] = $this->TableName;
		$this->PrefixedTableName = $this->Context->Configuration['DATABASE_TABLE_PREFIX'].$this->TableName;
		$this->Context->DatabaseColumns[$this->TableName]['MessageID'] = 'MessageID';
		$this->Context->DatabaseColumns[$this->TableName]['SenderID'] = 'SenderID';
		$this->Context->DatabaseColumns[$this->TableName]['RecieverID'] = 'RecieverID';
		$this->Context->DatabaseColumns[$this->TableName]['Message'] = 'Message';
		$this->Context->DatabaseColumns[$this->TableName]['DateCreated'] = 'DateCreated';
		$this->Context->DatabaseColumns[$this->TableName]['Hidden'] = 'Hidden';
		$this->Context->DatabaseColumns[$this->TableName]['Visited'] = 'Visited';
	}

/* =Class Functions
--------- --------- --------- --------- --------- --------- --------- */


	/*////////////////////////////////
	//  @name:  		CreateMessage
	//  @description:   Inserts Message to the Database
	//  @param: 		Object User
	//  @return:		
	*/
	function CreateMessage($SenderID, $RecieverID, $Message) {

		$s = $this->Context->ObjectFactory->NewContextObject($this->Context, "SqlBuilder");
		$s->SetMainTable($this->TableName, "m");
		$s->AddFieldNameValue("SenderID", $SenderID);
		$s->AddFieldNameValue("RecieverID", $RecieverID);
		$s->AddFieldNameValue("Message", $Message);
		$s->AddFieldNameValue("DateCreated", "", 0, "NOW");
		
		return $this->Context->Database->Insert($s, $this->Name, "CreateMessage", "An error while inserting a messages.");
		
	}

	
	/*////////////////////////////////
	//  @name:  		GetMessages
	//  @description:   Gets Messages from Database
	//  @param: 		Integer UserID
	//  @return:		Dataset
	*/
	function GetMessages($UserID) {

		$s = $this->Context->ObjectFactory->NewContextObject($this->Context, "SqlBuilder");
		$s->SetMainTable($this->TableName, "m");
		$s->AddSelect(array("MessageID", "SenderID", "RecieverID", "Message", "DateCreated"), "m");
		$s->AddWhere("m", "RecieverID", "", $UserID, "=");
		$s->AddWhere("m", "Hidden", "", 0, "=");
		$s->AddOrderBy("MessageID", "m", "DESC");
				
		$DataSet = $this->Context->Database->Select($s, $this->Name, "GetMessages", "An error while getting messages.");

		$s->Clear();
		$s->SetMainTable($this->TableName, "m");
		$s->AddFieldNameValue("Visited", 1);
		$s->AddWhere("m", "RecieverID", "", $UserID, "=");
		$this->Context->Database->Update($s, $this->Name, "GetMessages", "An error while getting messages.");

		return $DataSet;
		
	}

	/*////////////////////////////////
	//  @name:  		HideMessage
	//  @description:   Gets Messages from Database
	//  @param: 		Object User
	//  @return:		
	*/
	function HideMessage($MessageID) {

		$s = $this->Context->ObjectFactory->NewContextObject($this->Context, "SqlBuilder");
		$s->SetMainTable($this->TableName, "m");
		$s->AddFieldNameValue("Hidden", 1);
		$s->AddWhere("m", "MessageID", "", $MessageID, "=");
		
		$this->Context->Database->Update($s, $this->Name, "HideMessage", "An error while attempting to hide the messages.");
		
	}

	/*////////////////////////////////
	//  @name:  		HideAllMessages
	//  @description:   Gets Messages from Database
	//  @param: 		Object User
	//  @return:		
	*/
	function HideAllMessages($UserID) {

		$s = $this->Context->ObjectFactory->NewContextObject($this->Context, "SqlBuilder");
		$s->SetMainTable($this->TableName, "m");
		$s->AddFieldNameValue("Hidden", 1);
		$s->AddWhere("m", "UserID", "", $UserID, "=");
		
		$this->Context->Database->Update($s, $this->Name, "HideAllMessages", "An error while attempting to hide all messages for an user.");
		
	}

	/*////////////////////////////////
	//  @name:  		GetNumberOfNewMessages
	//  @description:   Gets the Number of New Messages from Database
	//  @param: 		Object User
	//  @return:		
	*/
	function GetNumberOfNewMessages($UserID) {

		$s = $this->Context->ObjectFactory->NewContextObject($this->Context, "SqlBuilder");
		$s->SetMainTable($this->TableName, "m");

		$s->AddSelect("RecieverID", "m", "NumberOfNewMessages", 'COUNT');
		
		$s->AddWhere("m", "RecieverID", "", $UserID, "=");
		$s->AddWhere("m", "Visited", "", 0, "=");

		$Dataset = $this->Context->Database->Select($s, $this->Name, "GetNumberOfNewMessages", "An error while attempting to hide all messages for an user.");

		$Row = mysql_fetch_assoc($Dataset);
		return ForceInt($Row['NumberOfNewMessages'], 0);
		
	}

/* =Delegation Functions
--------- --------- --------- --------- --------- --------- --------- */


	
/* =Meta Functions
--------- --------- --------- --------- --------- --------- --------- */

	/*////////////////////////////////
	//  @name:  		Install
	//  @description:   Adds a new Table to save User Messages
	//  @param: 		-
	//  @return:		-
	*/
	function Install() {
		$Sql = "SHOW TABLES LIKE '".$this->PrefixedTableName."'";

		$DataSet = $this->Context->Database->Execute($Sql, $this->Name, "Install", "An error occurred while checking if table ".$this->PrefixedTableName." exits in database");
		if($DataSet) {
			$Data = mysql_fetch_row($DataSet);
			
			if ($Data[0] != $this->TableName) { //check if table allready exists
				$Sql = "CREATE TABLE ".$this->PrefixedTableName." (
									MessageID BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY,
									SenderID INT NOT NULL,
									RecieverID INT NOT NULL,
									Message TEXT NOT NULL,
									DateCreated DATE NOT NULL,
									Hidden ENUM('0', '1') NOT NULL DEFAULT '0',
									Visited ENUM('0', '1') NOT NULL DEFAULT '0'
								) COMMENT = 'created by UserMessages Extension';";
				$this->Context->Database->Execute($Sql, $this->Name, "Install", "An error occurred while creating a new table");
			}
			//I want to print out an success message without using an own control.
			//Possible?
			$cm = $this->Context->ObjectFactory->NewContextObject($this->Context, 'ConfigurationManager');
			$cm->DefineSetting('UserMessages_INSTALLED', 1);
			$cm->Settings['UserMessages_INSTALLED'] = 0;
			$SettingsFile = $this->Context->Configuration['APPLICATION_PATH'].'conf/settings.php';
			$cm->SaveSettingsToFile($SettingsFile);
	
		}
	}

} //end of UserMessage class


/*////////////////////////////////
//  @name:  		UserMessageSendForm
//  @description: 	Handels Inputs
*/

class UserMessageSendForm extends PostBackControl {

/* =Editable Variables 
--------- --------- --------- --------- --------- --------- --------- */

	function UserMessageSendForm(&$Context) {
		
    $this->Name = 'UserMessageSendForm';


		$UserManager = $Context->ObjectFactory->NewContextObject($Context, "UserManager");
		$AccountUserID = ForceIncomingInt("u", $Context->Session->UserID);
		$this->AccountUser = $UserManager->GetUserById($AccountUserID);
		
    $this->Context = &$Context;
		$this->ValidActions = array('SendMessage');
		$this->Constructor($Context);

		$this->Message = ForceIncomingString("Message", "");

		$this->PostBackParams->Set('u', $this->AccountUser->UserID);
   	$this->PostBackParams->Set('PostBackAction', 'SendMessage');
   	$this->PostBackParams->Set('RecieverID', $this->AccountUser->UserID);
   	
		if ($this->IsPostBack) {
			$_POST['PostBackAction'] = "";

		}
		
	}
		
	function Render() {
		$Sent = false;
		if ($this->IsPostBack) {

			$RecieverID = ForceIncomingInt("RecieverID", 0);
			$SenderID = $this->Context->Session->UserID;

			if ($RecieverID == 0 || $SenderID == 0) {
				$this->Context->WarningCollector->Add($this->Context->GetDefinition('Sender or Reciever unknown!'));
			}
			if ($this->Message == "") {
				$this->Context->WarningCollector->Add($this->Context->GetDefinition('No Message provided!'));
			}
			if ($this->Context->WarningCollector->Iif()) {
				$um = $this->Context->ObjectFactory->NewContextObject($this->Context, "UserMessages");
				$um->CreateMessage($SenderID, $RecieverID, $this->Message);
				$Sent = true;
			}
			
		}

		echo '<div id="Telegramm">';
		echo $this->Get_PostBackForm('frmUserMessage');
		echo '<h4>';
		if ($Sent) {
			echo '<strong>Success! Message sent to </strong>';
			$this->Message = '';
		} else {
			echo 'Send a Message to: '; 
		}
		echo $this->AccountUser->Name;
		echo '</h4>';
		echo $this->Get_Warnings();
		echo '<input type="text" maxlength="160" name="Message" value="'.$this->Message.'" class="Text" />';
		echo '<input type="submit" value="Send" name="Send" class="Button" />';
		echo '</form>';
		echo '</div>';
	}

} //end of UserMessagesSendForm control

/*////////////////////////////////
//  @name:  		UserMessageViewForm
//  @description: 	Shows Messages
*/

class UserMessageViewForm extends PostBackControl {

/* =Editable Variables 
--------- --------- --------- --------- --------- --------- --------- */

	function UserMessageViewForm(&$Context) {
		
    $this->Name = 'UserMessageViewForm';
    $this->Context = &$Context;

		$this->Constructor($Context);

		$um = $this->Context->ObjectFactory->NewContextObject($this->Context, "UserMessages");

		$this->Messages = $um->GetMessages($this->Context->Session->UserID);

   	$this->PostBackAction = '';
   	
		if ($this->IsPostBack) {
			$_POST['PostBackAction'] = "Identity";

		}
		
	}
		
	function Render() {

		echo '<h3>Your Messages</h3>';
		echo '<div id="Messages">';
		$NoMessages = true;
		while ($Data = mysql_fetch_assoc($this->Messages)) {

			echo '<div class="Message">';
			$NoMessages = false;
			$UserManager = $this->Context->ObjectFactory->NewContextObject($this->Context, "UserManager");
			$u = $UserManager->GetUserById($Data['SenderID']);
			$UserList = '';
				$UserList .= '<div class="Sender">';
				if ($u->DisplayIcon != "") {
					$UserList .= '<img src="'.$u->DisplayIcon.'" alt="Icon" class="Icon" width="30" height="30" />';
				}
				$UserList .= '<a href="'.GetUrl($this->Context->Configuration, 'account.php', '', 'u', $u->UserID).'">'.$u->Name.'</a>';
				$UserList .= '</div>';
				
				echo $UserList;
				echo '<div class="Text">';
				echo '<p class="meta">'.$Data['DateCreated'].'</p>';
				echo '<p class="message">'.$Data['Message'].'</p>';
				echo '</div>';
			echo '</div>';
		}
		if ($NoMessages) {
			echo '<p>No Messages for you</p>';
		}
		echo '</div>';
	}

} //end of UserMessagesViewForm control


/* =Installation Check
--------- --------- --------- --------- --------- --------- --------- */
if(!array_key_exists('UserMessages_INSTALLED', $Context->Configuration)) {
	if ($Context->SelfUrl == 'settings.php' && ForceIncomingString("PostBackAction", "") == 'InstallUserMessages') {
		$um = $Context->ObjectFactory->NewContextObject($Context, "UserMessages");
		$um->Install();
	}
} else {

	if ($Context->SelfUrl == 'account.php' && (ForceIncomingString('PostBackAction', '') == "" || ForceIncomingString('PostBackAction', '') == "SendMessage")) {
		$MessageForm = $Context->ObjectFactory->CreateControl($Context, "UserMessageSendForm");
		$Page->AddRenderControl($MessageForm, $Configuration["CONTROL_POSITION_BODY_ITEM"]);
	}

	if ($Context->SelfUrl == 'account.php' && ForceIncomingString('PostBackAction', '') == "Identity") {
		$MessageViewForm = $Context->ObjectFactory->CreateControl($Context, "UserMessageViewForm");
		$Page->AddRenderControl($MessageViewForm, $Configuration["CONTROL_POSITION_BODY_ITEM"] + 1);
	}

} //if Installed

?>